Index: src/Fl_cocoa.mm
===================================================================
--- src/Fl_cocoa.mm	(revision 12107)
+++ src/Fl_cocoa.mm	(working copy)
@@ -2898,9 +2898,11 @@
   } else {
     if (w->resizable()) {
       Fl_Widget *o = w->resizable();
-      int minw = o->w(); if (minw > 100) minw = 100;
-      int minh = o->h(); if (minh > 100) minh = 100;
-      w->size_range(w->w() - o->w() + minw, w->h() - o->h() + minh, 0, 0);
+      int minw = w->w();                     // minw is window's initial width
+      int minh = w->h();                     // minh is window's initial height
+      int maxw = (o->w() == 0) ? minw : 0;   // if resizable w()==0, disable resize w()
+      int maxh = (o->h() == 0) ? minh : 0;   // if resizable h()==0, disable resize h()
+      w->size_range(minw, minh, maxw, maxh);
       if (w->border()) winstyle |= NSResizableWindowMask;
     } else {
       w->size_range(w->w(), w->h(), w->w(), w->h());
Index: src/Fl_win32.cxx
===================================================================
--- src/Fl_win32.cxx	(revision 12107)
+++ src/Fl_win32.cxx	(working copy)
@@ -1731,9 +1731,11 @@
     if (!size_range_set()) {
       if (w->resizable()) {
 	Fl_Widget *o = w->resizable();
-	int minw = o->w(); if (minw > 100) minw = 100;
-	int minh = o->h(); if (minh > 100) minh = 100;
-	w->size_range(w->w() - o->w() + minw, w->h() - o->h() + minh, 0, 0);
+	int minw = w->w();                     // minw is window's initial width
+	int minh = w->h();                     // minh is window's initial height
+	int maxw = (o->w() == 0) ? minw : 0;   // if resizable w()==0, disable resize w()
+	int maxh = (o->h() == 0) ? minh : 0;   // if resizable h()==0, disable resize h()
+	w->size_range(minw, minh, maxw, maxh);
       } else {
 	w->size_range(w->w(), w->h(), w->w(), w->h());
       }
Index: src/Fl_x.cxx
===================================================================
--- src/Fl_x.cxx	(revision 12107)
+++ src/Fl_x.cxx	(working copy)
@@ -2514,9 +2514,11 @@
   if (!size_range_set()) { // default size_range based on resizable():
     if (w->resizable()) {
       Fl_Widget *o = w->resizable();
-      int minw = o->w(); if (minw > 100) minw = 100;
-      int minh = o->h(); if (minh > 100) minh = 100;
-      w->size_range(w->w() - o->w() + minw, w->h() - o->h() + minh, 0, 0);
+      int minw = w->w();                     // minw is window's initial width
+      int minh = w->h();                     // minh is window's initial height
+      int maxw = (o->w() == 0) ? minw : 0;   // if resizable w()==0, disable resize w()
+      int maxh = (o->h() == 0) ? minh : 0;   // if resizable h()==0, disable resize h()
+      w->size_range(minw, minh, maxw, maxh);
     } else {
       w->size_range(w->w(), w->h(), w->w(), w->h());
     }
